/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { FinancialIndicator } from "./FinancialIndicator";
import { String_$type, Number_$type, typeCast, fromEnum, markType } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { List$1 } from "igniteui-react-core";
import { AxisRange } from "./AxisRange";
import { isNaN_ } from "igniteui-react-core";
/**
 * @hidden
 */
var StrategyBasedIndicator = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(StrategyBasedIndicator, _super);
    function StrategyBasedIndicator() {
        var _this = _super.call(this) || this;
        _this.ab0();
        return _this;
    }
    StrategyBasedIndicator.prototype.ab0 = function () {
        this.abl = this.abm;
        this.ab = this.abz;
    };
    StrategyBasedIndicator.prototype.abs = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.ab1 = function (a) {
    };
    StrategyBasedIndicator.prototype.abu = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.prototype.abr = function () {
        return -2147483648;
    };
    StrategyBasedIndicator.ab5 = function (a, b, c) {
        var d = DependencyProperty.i(c, Number_$type, b, new PropertyMetadata(2, a, function (e, f) { return (typeCast(StrategyBasedIndicator.$, e)).raisePropertyChanged(c, f.oldValue, f.newValue); }));
        StrategyBasedIndicator.abp.add(c);
        return d;
    };
    StrategyBasedIndicator.ab4 = function (a, b) {
        return StrategyBasedIndicator.ab5(a, b, "Period");
    };
    StrategyBasedIndicator.ab2 = function (a, b) {
        return StrategyBasedIndicator.ab5(a, b, "LongPeriod");
    };
    StrategyBasedIndicator.ab6 = function (a, b) {
        return StrategyBasedIndicator.ab5(a, b, "ShortPeriod");
    };
    StrategyBasedIndicator.prototype.aay = function (a, b) {
        var c = this.xa(a, b);
        var d = this.xb(c);
        return this.abl.b(c, d);
    };
    StrategyBasedIndicator.prototype.aav = function (a, b) {
        var c = this.xa(a, b);
        if (b == 0) {
            return false;
        }
        if (!this.x6(this.aay(a, b))) {
            return false;
        }
        var d = this.xb(c);
        if (this.aar != null) {
            c.minimumValue = this.aar.c;
            c.maximumValue = this.aar.b;
        }
        var e = this.abl.a(c, d);
        for (var f = 0; f < this.aa0 && f < c.indicatorColumn.count; f++) {
            c.indicatorColumn.item(f, NaN);
        }
        if (this.xg != null && this.abo(c)) {
            this.xg.c1();
        }
        return e;
    };
    StrategyBasedIndicator.prototype.abo = function (a) {
        var e_1, _a;
        if (!isNaN_(a.minimumValue) && !isNaN_(a.maximumValue) && a.specifiesRange) {
            var b = this.aar;
            this.aar = new AxisRange(a.minimumValue, a.maximumValue);
            return this.abn(b, this.aar);
        }
        var c = 1.7976931348623157E+308;
        var d = -1.7976931348623157E+308;
        try {
            for (var _b = __values(fromEnum(a.indicatorColumn)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                if (!isNaN_(e)) {
                    c = Math.min(c, e);
                    d = Math.max(d, e);
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        var f = this.aar;
        this.aar = new AxisRange(c, d);
        return this.abn(f, this.aar);
    };
    StrategyBasedIndicator.prototype.abn = function (a, b) {
        if (a == null || b == null) {
            return true;
        }
        if (a.c != b.c) {
            return true;
        }
        if (a.b != b.b) {
            return true;
        }
        return false;
    };
    StrategyBasedIndicator.prototype.abt = function (a) {
        if (a == -2147483648) {
            return 0;
        }
        if (a > this.indicatorColumn.count && this.indicatorColumn.count > 0) {
            a = this.indicatorColumn.count - 1;
        }
        if (a < 1) {
            return 1;
        }
        return a;
    };
    StrategyBasedIndicator.prototype.xa = function (a, b) {
        var c = _super.prototype.xa.call(this, a, b);
        c.indicatorColumn = this.indicatorColumn;
        c.period = this.abt(this.abs());
        c.shortPeriod = this.abt(this.abu());
        c.longPeriod = this.abt(this.abr());
        c.multiplier = this.abq();
        return c;
    };
    StrategyBasedIndicator.prototype.abq = function () {
        return 1;
    };
    StrategyBasedIndicator.ab3 = function (a, b) {
        var c = DependencyProperty.i("Multiplier", Number_$type, b, new PropertyMetadata(2, a, function (d, e) { return (typeCast(StrategyBasedIndicator.$, d)).raisePropertyChanged("Multiplier", e.oldValue, e.newValue); }));
        StrategyBasedIndicator.abp.add("Multiplier");
        return c;
    };
    StrategyBasedIndicator.prototype.q4 = function (a, b, c, d) {
        _super.prototype.q4.call(this, a, b, c, d);
        if (StrategyBasedIndicator.abp.contains(b)) {
            if (this.xg != null && !this.xg.c1()) {
                this.xe.b0.e(this.ib);
                this.aav(0, this.indicatorColumn.count);
                if (this.aas.ca) {
                    this.aas.b8.g$i();
                }
                this.rm(false);
            }
        }
    };
    StrategyBasedIndicator.$t = markType(StrategyBasedIndicator, 'StrategyBasedIndicator', FinancialIndicator.$);
    StrategyBasedIndicator.abp = new List$1(String_$type, 0);
    return StrategyBasedIndicator;
}(FinancialIndicator));
export { StrategyBasedIndicator };
